\documentclass[11pt]{article}
\usepackage[serbianc]{babel}
\usepackage{listingsutf8}
\usepackage[unicode]{hyperref}
\usepackage[margin=2cm]{geometry}

\lstdefinelanguage{macroscr}
                  {morecomment=[l]{@/},
                    moredelim=[s]{@[}{@]}
                    }

\lstdefinelanguage{macromac}
                  {morekeywords={DEKLARACIJE,MAKRO,RAZVOJ,MENJA},
                    morecomment=[l]{//}
                    }

\lstdefinelanguage{macrotem}
                  {morekeywords={@KORISTI,@RAZVI},
                    morecomment=[l]{@/}
                    }
                  
\begin{document}

\lstset{frame=single,numbers=left,numberstyle=\tiny}

\title{Program for MAKRO - expansion\\user manual}
\author{GVS Ko, Belgrade}
\date{May 2024}
\maketitle

\tableofcontents

\sloppy




\section{Generally about MAKRO expansions}

MAKRO-expansions is a tool made for  automatic code generation, primarily 
C and C++ source code. The tool itself, however, is not limited
only to these languages and is applicable to any text files.
In theory, binaries can also be created, but that is not the
intended use - it's \textit{not easy} at all.

The purpose of MAKRO-expansion is to make more files (source code, documentation,...)
generated using a small amount of information. It is shown, namely, that in
programming, there is often a simple way to describe the problem, but that
for the most effective implementation, it is necessary to write and maintain
a large number of source file, scripts, headers, which must be coordinated with each other.

A good example of this phenomenon is user interface: in many applications it is
enough just to specify the list of operator commands and the types of their parameters, but
in programming you need to define menus, dialogs, constants for commands,
functions for setting and reading values entered in the dialog, functions for
checking, error processing, etc. If the user interface is uniform,
knowing the starting list of operator commands, it is possible to get all
necessary files automatically and it is a job that can be entrusted to MAKRO-
expansions. Precisely, from the same definition, a textual conjunction can be obtained
(for the command line).

MAKRO-expansions, by the way, perform work that in its essence can also be entrusted to the C preprocessor.
Namely, the information used to generate the files can be defined as
C macros (if necessary - in several ways). Of course,
for this it is necessary to include these macros in some ``template'' file in as many
places needed. Before inclusion, all these macros should be defined, and after inclusion - 
undefined, so that they can be reused in a different way in the next one
inclusion. This is known in the ``C-world'' as \textsf{XMacro}, see
\textsf{https://en.wikipedia.org/wiki/X\_Macro}. 

The described way of using the C preprocessor was the motivation for
design of MAKRO expansion. MAKRO expansions have certain advantages:

\begin{itemize}

\item The code generated by the C preprocessor is usually unreviewed.
  More precisely, everything obtained by calling one macro is translated into
  the same line of text, which makes it difficult to debug the resulting code. With MAKRO
  expansions, the user has full control over character expansion for the newlines
  and whitespace.

\item Code generated by the C preprocessor cannot have preprocessors
  directives. In code generated by MAKRO expansions, C preprocessors
  directives have no meaning. In this way, the code generated by the MAKRO
  expansions can be further processed by the C preprocessor. This is before
  all useful for \verb+#error+ and \verb+#pragma+ preprocessors
  orders.

\item MAKRO expansions allow more transparent definition of macros and theirs
  calling against the C preprocessor. This means that the user does not have to
  care about undefining macros once they are used, whether
  all macros are defined in each expansion, with the same parameters
  etc.  MAKRO expansions also provide more detailed error reporting if
  the user does not comply with these rules.

\item Since version 1.1, MAKRO expansions have also the ability for a new
  expansion to change an existing expansions, which resembles inheritance from OO
  programming. This can significantly reduce the amount of code required,
  especially if we have many macros.

\item Since version 1.4, the ability to make a block-macro which can be
  opened and then closed, similar to SGML/HTML tags

\item Since version 1.5, it is possible to use block macro's parameters in a macro
  which is located in that block.

\item Since version 1.6, a function can be called instead of simply
  inserting the macro parameter, with function taking up to one
  parameter.

\item As a rule, MAKRO expansions are faster, because the language is simpler
  from the C preprocessor.

\end{itemize}




\section{Installation}

MAKRO - expansions do not require special installation. They consist of one program
which can be directly executed in any executable environment
ISO C++ standard programs (Windows, Linux, BSD, MacOS...).

Since it uses plain text files, they can be made with any text
editor. So far, no support has been made for editors and IDEs for the purpose of 
``highlighting'' and the like.




\section{Input and output of MAKRO-expansion}

\subsection{General}

For automatic generation, MAKRO-expansions use three types of input files, 
each having its own format:
\begin{itemize}
\item script-file
\item template-file
\item macro-file
\end{itemize}

In all three cases, they are text files. The output represents one
file that should meet the appropriate needs - it can be
programming language source code, documentation, help file,
header or whatever. Of course, in case of automatic generation of
multiple files, MAKRO-expansions should be performed for each output file
separately.

As of version 1.3, input files are interpreted as if they were in UTF-8 format.
This is a very limited interpretation, in the sense that incorrectly coded
UTF-8 files will most likely not be flagged, but processed and thus probably 
invalid files will appear on the output.
There is explicit support for UTF-8 for
identifiers - Cyrillic letters are allowed as identifier letters in
Unicode range $400_{16}$ to $45F_{16}$. So it's limited to
Cyrillic letters and only of that range - although the specified range contains
the vast majority of all letters of all living Cyrillic alphabets.

MAKRO-expansions are performed with:

\begin{verbatim}
makro <script-file> <template-file> <output-file>
\end{verbatim}

At the same time, the macro-file used is not specified, but is declared inside
script-files as will be explained.

In the case of successful translation and generation of the output file, 
a success message is written to the standard output, and in case of an error - 
a message about the first error (with information about the file and line number 
in which the error occurred), after which translation stops. MAKRO returns (to operating system)
status 0 in case of successful execution and 1 in case of error, for use in various scripts.



\subsection{Script file}

A script file is a text file that contains macro definition
data. It's a ``brief description'' that needs to be translated into (potentially)
long source file. In a way, the script file is the basic
input file for MAKRO- expansion, while template-file and macro-file,
specify the way to translate the script file into an output file.

A script file (or just ``script'') consists primarily of ``calls'' to
macros.  Macros are declarations that will be expanded in the output file
into specific strings, as needed. The macros are expanded one or more times
in the output file, each time in a different way, which
is specified by template-file and macro-file.

Apart from calling macros, other scripts can be included in the script
files, much like in the C preprocessor one can \verb+#include+ a file.



\subsection{Template-file}

A template file (or just ``template'') contains parts of the output file
independent of scripts. In other words, the output file is a template
refined (primarily completed) using declarations from scripts. 
In certain places within the template there are commands that determine what
exapnsion must appear in the appropriate place of the output file, after 
which it continues with the content from the template until the next 
such order.

It is also possible to include another file in the template, but not 
another template file, just a plain text file. So far, no need to 
include another template has been observed.



\subsection{Macro-file}

A macro file contains macro definitions. It has to contain declarations
for all macros used in the script. In the macro file macros are declared once, 
and defined as many times as there are different expansions.  
At each place in the template-file where
there are commands to include the expanded script, one of the expansions defined
in the macro-file  will be used to expand the macros from script.

Each set of macro definitions represents one expansion. There is an option
that one expansion changes some existing expansion, which reminds of
inheritance from OO programming. In such a expansion, it is possible to define
only those macros that we want to change, while the others are copied from
base expansion without changes. This can be a great relief if
there are many macros and many expansions, some of which are very similar.




\section{Syntax}

This chapter describes the syntax of MAKRO expansion. The general 
syntax elements, as well as the syntax of certain types of files, are
described.



\subsection{Identifiers}

Identifiers are used in MAKRO expansions as macro names, names
expansion and names of formal macro parameters. The identifier is a string
of symbols (characters) which can be: letters, numbers and underline
(\_), where a digit cannot be the first symbol.  The letter can be ASCII
Latin letter or UTF-8 Cyrillic letter from the range $400_{16}$ to
$45F_{16}$.  When extracting the identifier, 
the longest string of symbols representing the identifier is taken.  The identifier can
be of arbitrary length, but only the first 32 symbols are significant.  The
case of the letters i important for distinguishing identifiers,
for example. \verb+Macro+, \verb+MaKrO+ and \verb+MAKRO+ are different
identifiers.



\subsection{Script file syntax}

\subsubsection{Macro Calls}

A script consists of one or more macro calls. Thereby,
we can understand the inclusion of another script file as just one
type of syntax sugar.

Each macro call takes one of the following forms:

\begin{verbatim}
@@<macro name>
\end{verbatim}

or:

\begin{verbatim}
@@<macro name>(<parameter list>)
\end{verbatim}

The first form is reserved for macros without parameters. In second form,
the parameter list consists of macro parameters separated by
commas. It can also be empty, in which case this form is
equivalent to the first form. The macro name is an identifier.

As for macro parameters, they can be any characters,
including newline, blank and tab characters, as well as commas and
brackets, except the \verb+@+ character.

MAKRO expansions based on the macro-file have information about the number
of parameters for each macro. Attempting to use a macro without parameters,
if they are declared, or with parameters if they are not declared, or
with an inappropriate number of parameters, as well as an attempt to use a macro
that is not declared will be reported as errors.

\subsubsection{Block Macros}

A single macro can support a special opening and a special closing,
similar to tags in SGML/HTML. We call such macro a \textbf{block-macro}.

A block macro is opened by calling as described above. It closes with:

\begin{verbatim}
@.<macro name>
\end{verbatim}

Therefore, instead of the second ``at'', there is a period is. When closing the macro
parameters cannot be given. The macro being close must actually be a block macro,
that is,  have a defined closing expansion.

If a macro that is not open is closed or at the end of the file
if a macro block is left open (unclosed), an error will be reported.

Block macros can be ``nested'', that is, it is not necessary to
close one macro block before opening a new one, whether it's the same or
different name of the (block) macro.

Block macros can often be a more transparent solution than nested ones
macros \ref{sec:ugnyezxdeni-pozivi-macroa}.


\subsubsection{Extracting macro parameters containing the symbols ',' and ')'}

In case the parameter does not contain the symbols \verb+,+ (comma) and
\verb+)+ (right/closed parenthesis), it can be written in normal
way, and MAKRO expansions recognize the end of a parameter when they encounter one
of these two symbols.

In case you want the symbols \verb+,+ and
\verb+)+ in parameters, this can be done using special symbols
\verb+@[+ and \verb+@]+. The first of them represents an ``open parenthesis'',
within which all symbols are included in the parameter, up to the second -
``closed brackets''. The symbols \verb+@[+ and \verb+@]+ themselves are not included
into a parameter. They cannot be nested - after the symbol \verb+@[+ it is not
correct to have the symbol \verb+@[+ again (except in the case
described in section \ref{sec:ugnyezxdeni-pozivi-macroa}).


\subsubsection{Nested Macro Calls}\label{sec:ugnyezxdeni-pozivi-macroa}

New macro calls can be found within the parameters of one macro call. 
When macro parameters are specified, these macros in parameters are collected
and expanded. The role of parentheses and commas in these ``nested'' macros
is the same as for the starting macro, so it is possible, in a nested macro,
to use the symbols \verb+,+ and \verb+)+, as well as \verb+@[+ and \verb+@]+
in order to delimit the parameters. This practically leads to the fact that
the symbols \verb+@[+ and \verb+@]+ can, in a way, be nested, but
just so that one group of symbols delimits the parameters for a given macro, and
the second group – for its nested macros.

If inside a macro parameter there is a nested call of another
macro, this call consists, in case it has parameters, of all symbols
to the last right bracket in this call, conclusively. If that nested
call has no parameters, it consists only of its name, i.e. first symbol
after the end of the name of the nested macro enters the parameter of the outer macro.


\subsubsection{Script Comments}

Within scripts, each \verb+@/+ symbol represents the start of a comment,
wherever it is (inside the macro or outside). All symbols from that symbol to
the end of line are ignored, including the end of line itself. In that manner,
by putting the symbol \verb+@/+ at the end of the line, it is practically possible to join
script lines during processing.


\subsubsection{Including another script}

The inclusion of another script is specified by specifying the file between symbols
\verb+@"+ and \verb+"+.  So if we want to include the script
\verb+123.scr+, we should write \verb+@"123.scr"+.

The included script may further include a third script. There are no limits
in the program itself, but operating systems generally have
limits on the number of files open at one time.


\subsubsection{Examples}

\begin{enumerate}

\item Call: \textsf{@@Macro1(ABC,DEF,GHI)} represents a macro call
Macro1 with three parameters: ABC, DEF and GHI.

\item Call: \textsf{@@Macro2(@[ABC,DEF@],GHI)} represents the call of Macro2 macro with two
parameters: ABC, DEF and GHI.

\item The previous call of the macro can be written just like this:
\textsf{@@Macro2(ABC@[,@]DEF,GHI)} (only the comma is delimited by symbols \textsf{@[} and \textsf{@]})

\item Call: \textsf{@@Makro3()} represents the call of the Makro3 macro without parameters

\item The previous macro call can also be written just like this: \textsf{@@Macro3}

\item Call: \textsf{@@Macro4(AB@@Macro5(X,Y),@@Macro6(@[X,Y@]))}
  represents a macro call \textsf{Macro4} with two parameters. First
  is created by adding the result of expansion to \textsf{AB}
  macros \textsf{Macro5} with two parameters: \textsf{X} i
  \textsf{Y}. The second is the result of expanding the macro \textsf{Macro6}
  with one parameter: \textsf{X,Y}.

\item There are parentheses inside the previous call, but they are integral
  part of ``nested'' macros, so it is not necessary to specify symbols
  \textsf{@[} and \textsf{@]} at macro level \textsf{Macro4}.  On the other hand, 
  parentheses can also be specified at the base macro level.  so,
  call: \textsf{@@Macro7(@[AB@@Macro5(X,Y),@@Macro6(@[X,Y@])@])}
  represents a macro call \textsf{Macro7} with one parameter, which
  is obtained by appending to \textsf{AB}: the result of expansion
  of macro \textsf{Macro5} with two parameters: \textsf{X} and \textsf{Y},
  one symbol \textsf{,} (comma) and the result of developing the macro
  \textsf{Macro6} with one parameter: \textsf{X,Y}.

\item Call:
\begin{verbatim}
@@Macro8(@/ This macro is for example 8
par1,@/ The first parameter
par2@/ Second parameter
)
\end{verbatim}
represents a macro call Makro8 with two parameters: par1 and par2.

\item Call:
\begin{verbatim}
@@Macro9(
   par1,@/ The first parameter
   par2@/ Second parameter
)
\end{verbatim}

(parameters are preceded by three blank characters) represents a macro call
Macro9 with two parameters: \textsf{<nr><b><b><b>par1} i
\textsf{<b><b><b>par2} (with \textsf{<b>} a blank character is marked, and with
\textsf{<nr>} – character for new line).

\item Call: \textsf{@@Makro10(@@Makro11ABC)} represents the macro call
  Macro10 whose parameter is the result of expanding Macro11ABC macro. If
  however, we want the Macro10 macro call parameter to be the result of
  expansion of the Makro11 macro, which is followed by the symbols ABC,  itcan be done
  with the call like this: \textsf{@@Makro10(@@Makro11()ABC)} or
  \textsf{@@Macro10(@@Macro11@[@]ABC)} (symbols \textsf{@[} and
    \textsf{@]} do not enclose anything, but separate identifier
  \textsf{Macro11} from the symbol \textsf{ABC}.

\end{enumerate}



\subsection{Macro-File Syntax}

A macro file consists of two sections: the macro declarationa and
macro definitiona. In the macro declaration section, the macros'
names and parameters are listed. The macro definitions section is divided into
expansions. Each expansion has its own name (which is an identifier), and
represents a list of definitions for all macros that appear in the declaration
section. When a template requires the inclusion of a translated script, 
the corresponding template command defines the expansion by which the macros 
will be expanded.


\subsubsection{Macro Declarations Section}

The macro declarations section begins with the keyword \textsf{DEKLARACIJE},
followed by a series of macro declarations. This section ends with a symbol
\verb+@@+. Each macro declaration is of the form: <macro name> or <macro
name>(<list of formal parameters>). The name of the macro is an identifier, and
the list of formal parameters is a list of separated identifiers
commas. This declaration specifies the number of macro parameters: first
form declares a macro without parameters, and the second form – a macro
which has as many parameters as the identifiers specified in the list.
In particular, the list can be empty, which also specifies there are no macro
parameters.  The same macro cannot appear twice in the declaration section,
even if given a different number of parameters.

\subsubsection{Develop}

Every expansion starts with an expansion declaration:

\begin{verbatim}
RAZVOJ <expansion name> [ MENJA <expansion name>]
\end{verbatim}

followed by a series of macro definitions for that expansion. As part of the expansion,
each of the macros declared in the declarations section must be defined
exactly once. Moreover, if the expansion changes an existing one, then it can
define only some macros (the ones it modifies).

The macro definition has the following form:

\begin{verbatim}
MAKRO <macro name>(<list of formal parameters>)<replacement>@@
\end{verbatim}

or:

\begin{verbatim}
MAKRO <macro name><replace>@@
\end{verbatim}

In the first form, the list of formal parameters must be matched verbatim
with a list of formal parameters in the declaration section: number of parameters and
their names, in the order they are listed, must be the same. Second form
indicates that the macro has as many parameters (and with such names) as
is declared in the declarations section. The first form is most often used
when the corresponding replacement contains formal parameters, for the sake of clarity,
and can always be replaced by second form.

Substitution represents a series of symbols  which the macro, when expanding, is 
replaced with. The symbols \verb+@@+ indicate the end of substitution for given
macro. Any symbols other than symbols can be found inside the substitution
\verb+@+ – even spaces, tabs, newlines and more
special characters. Formal parameters can exist, bounded in front and
behind the symbols \verb+@+. During expansion, these parameters are replaced
by the actual parameters from the scripts, or, if there is no such parameter,
it will try to call a function with the appropriate name.

The \verb+@+ symbol at the end of the line is ignored inside the replacement along with the
new line character after it. In this way, it is possible for the
macro-file, for the sake of clarity, to have additional newline characters
which do not enter into expansion when replacing. This is similar to using \verb+\+
in the C preprocessor.


\subsubsection{Block Macros}

Block macros are not declared explicitly. For a macro to become a block
macro, it is necessary to define the expansion of its closure (``end'').
Similar to calling macros from scripts, this is accomplished by placing a dot before the
macro name, such as:

\begin{verbatim}
MAKRO .<macro name><replace>@@
\end{verbatim}

The expansion of the closure will receive the parameters that were specified when opening the macro.
By convention, we do not specify these parameters, but, if desired, they can be specified.

\begin{verbatim}
MAKRO .<macro name>(<list of formal parameters>)<replacement>@@
\end{verbatim}

Of course, if specified, they must match the declaration of this macro.

Although there is no explicit check, practically, if a given macro has a defined
closure, then that macro will have to be a block macro in all expansions that
are used in the same template file. In practice, this generally means in all expansions
in the macro file.


\subsubsection{Using block macro arguments in macros within a block}

A macro that is called within a macro block can be called
with the same arguments of the macro block opening in which it is located.  
In the macro definition one should specify the block-macro name, followed by a period,
followed by the parameter name of the macro block we want to use.
Let's say:

\begin{verbatim}
MAKRO EnumVal(sys,vr,description) @Enum.name@_@sym@ = vr, /* @description@ */
\end{verbatim}

For the given definition to be correct:
\begin{enumerate}
  \item The macro \texttt{Enum} must exist
  \item The macro \texttt{Enum} must be a block macro in the current expansion
  \item The macro \texttt{Enum} must have a parameter \texttt{name}
\end{enumerate}

In particular, during the expansion of \texttt{EnumVal} in the script at least one
macro \texttt{Enum} must be open.  That is, something like this:

\begin{verbatim}
@@Enum(day)
    @@EnumVal(Mon,1,Monday)
@.Enum
\end{verbatim}


\subsubsection{Functions instead of parameters}

If in the definition of the macro instead of the parameter in the substitution we specify the name of a function,
then during expansion that function will be called and its result will be
placed in a given place. Obviously, if we named the parameter the same as
function, the parameter will take precedence.

Functions can have one parametar. In the definition of a macro,
after the function name, there should a dot and then the parameter.
If the parameter of the function is a parameter of the macro, it
will first be replaced and then the function called.

These functions are not ``pure'' math functions. They can have
internal state. One could think of them as ``functional objects'',
which can receive a message with up to one parameter (a string)
and they reply with another string (which is then placed in at the
calling site in the macro).

Apart from the result, and the state of the function, there is
a hidden running state. This running state is also a function.
Each function can use the running state, but also change it.
This is similar to Monads from Category Theory (see Haskell
programming language).

It is interesting that, since a function can only return one
string, then if there is a need to keep more than one datum
in the running state, we need to call it several times.
Each call needs to update the running state ``removing'' from
it the datum that was returned in that step.

Some functions have ``special abilities''. For example \textsf{uvedi}
- in English it would be named \textsf{introduce} or \textsf{define},
which defines a user function with the given name to be the same as
the current running state. After introduction, user functions are
equals with functions from the MAKRO standard library.

For each function from the standard library we document its
internal state, how it modified the running state and which
``special abilities'' it poseses.

New instantce of a function is created at the start of each
Development, at which point the running state is set a Null
function, which, if called, produces an error, stopping the
Development.

Even though the parameter and the result of a function are
always strings, they often have a different conceptual type,
which defines interpetation of the string. Math functions
will expect only digits, decimal points and such, while
logic functions would interpet string as a Boolean value.

For numbers, decimal point is always the dot.

For Booleans, we define that anything which is not false is
true. False is define as:

\begin{itemize}
\item empty string
\item Unicode ``not-true/bottom'' $\bot$ 
\item strings: \textsf{не} (Serbian Cyrrilic), \textsf{ne} (Latin) ,
  \textsf{no} and \textsf{false} and \textsf{нет} (Russian)
\end{itemize}

When returning, all functions return the Unicode ``true/top'' $\top$  for \textsf{true}, and an empty string for \textsf{false}.


\subsubsection{Available functions}

Even though functions form several logical groups, so far
there is no formal organization of these groups.

Several functions have Serbian names, and these name are used
as such in the documentation, but here we provide a dictionary
of sorts, which gives a good idea on the meaning of these
functions.

\begin{tabular}{l|l}
  Serbian Name & English name \\
  \hline
  negiraj      & negate \\
  jedini       & unique \\
  uvedi        & define \\
  uvedi\_novu  & define\_new\\
  izvrsxi      & execute\\
  zovi         & call\\
  odbaci       & dismiss\\
  zavrsxi      & finish\\
  ako          & if\\
  fako         & fif; functional if\\
  onda         & then\\
  fonda        & fthen; functional then\\
  inacxe       & else\\
  spram        & with\\
  fspram       & fwith; functional with\\
  kad          & when\\
  drukcxe      & otherwise\\
  osiguraj     & check\\
\end{tabular}

Keep in mind that, at the time of this writing, it is not
possible to actually use the listed English names.

\subsubsection{iota}

Popular Iota returns a subsequent integer on each call.

If called w/out parameter, returns the current integer and then
increments. Initial state is $0$. If the integer reaches some
unspecified large number (like $2^{32}$) it will wrap to zero.

Note that two calls to $iota$ in the \emph{same} macro will
give/return two \emph{different} values.

If one wants to start countin from one, the first call to $iota$
should be done ``into void''.

It is often a need to have more than one counter at the same time,
or to reset the counter. For that purpose, $iota$ can also accept
a parameter.

If the parameter is \texttt{nov}, then a new instance of $iota$ will
be created and set as the running state, while an empty string will be
returned. If the parameter has any other value, it's as if there
was no parameter.

Typically, this new counter should be defined as an user function
and then called as needed.

Following example illustrates how to count classes and members
of classes in the same Development. Syntax is C++, but that is
incidental, the example's focus is on 
\texttt{iota}, \texttt{iota.nov} and \texttt{uvedi}:

\begin{verbatim}
MAKRO Class(name)constexpr unsigned klass_@name@_id = @iota@; @iota.nov@@uvedi._iota@
class @name@ {@@
MAKRO Member(ime)int @name@;
static constexpr unsigned @name@_id = @_iota@;@@
MAKRO .Class static constexpr unsigned @name@_members = @_iota@;
};
\end{verbatim}


\subsubsection{jedini}

Enables cheking if an element is unique in a list.

If ``called'' without parameter, makes a new list to check and set it
as the running state. List is empty at start.

This ``checker'' is designed to be defined as an user function and then
called as needed later on.

If called with a parameter, it is searched for in the list. If
found, running stats is set to \texttt{false}, as the parameter
is not unique. If not found, it is added to the list and running
state set to \texttt{true}.

Empty string is returned always.

Keep in mind that this check is case sensitive.

The following example illustrates how to make sure all classes
have unique names and also all elements within a class have
unique names:

\begin{verbatim}
MAKRO Class(name)@jedini.name@@osiguraj@@jedini@@uvedi._uniq@@@
MAKRO Member(name)@_uniq.name@@@
\end{verbatim}


\subsubsection{negiraj}

The well known math logic / Boolean \emph{negation} function,
negates the running state.

Running state is called, result interpreted as Boolean, negated
and thus set as new running state. Always returns an empty string.


\subsubsection{regex}\label{sec:regex}

Forms regular expression for searching or replacing.

Parameter must start with a slash  \textsf{/}. The regular expression itself faolows, then another slash. If there is content after it, should be the replacement followed with the final slash.

Always returns an empty string and sets the running state to the
function for searching or replacment. If caller needs to execute
the regex more than once, should define an user function.

When searching, any part of the parameter that matches the regex
is accepted and returned. If no part matches, empty string is
returned.

When replacing, the POSIX  \textsf{sed} semantics are used. The
result of the replacement is retunred, which is an empty string
if regex is not matched.

\begin{verbatim}
MAKRO Klasa(ime)@regex./k/Klasa/@@uvedi._rk@
class @ime@ {@@
MAKRO Cxlan(ime)int @_rk.ime@@ime@;@@
MAKRO .Klasa
};
\end{verbatim}

\subsubsection{uvedi}

Function with special abilties. Parameter is the name under which the
running state can be called as a function, just like the ones from the
standard library. These are deemed \textbf{user functions}.

Names of user functions must start with underscore (\verb+_+).
Making a user function if the running state is void is not an
error, but calling such user function is.

If an user function with the same name already exists, it will
be replaced.

Always returns an empty string and does not alter the current
state.

Note that this is not a way to \emph{make} user functions, only
to \emph{name} the current running state so that user can call
it. Obviously it is useful only for functions that are especially
designed to create user functions, like the \textsf{regex}
described \ref{sec:regex}.

\subsubsection{uvedi\_novu}

The only difference to \textsf{uvedi} is that if given a name
of an already existing user function, this results in error.

\subsubsection{izvrsxi}

Simply calls/executes the running state.

If we only want to execute a regex once:

\begin{verbatim}
MAKRO Klasa(ime)@regex./k/Klasa/@@izvrsxi.ime@
@@
\end{verbatim}

\subsubsection{zovi}

Calls/executes the function given by the parameter, passing
no parameter to it (the same as passing an empty string).
Obviously useful only for functions where no parameter makes
sense.

Attempt to call a non-existant functions is an error.

For example, if we develop differently based on a macro parameter:

\begin{verbatim}
MAKRO Vehicle(name,kind)@zovi.kind@
@@
\end{verbatim}

We know that we have kinds of vehicle bicycle, motorbike, car...
and for each there is an user function with such name. This can
be much easier to read than a multiple branch.

\subsubsection{odbaci}

Dismisses the running state, setting it to null and void.

It is useful to prevent accidental use of the running state.
For example, the regex is used and we want to prevent its
accidental use going further.

\begin{verbatim}
MAKRO Klasa(name)@regex./k/Klasa/@@izvrsxi.name@@odbaci@
@@
\end{verbatim}

\subsubsection{zavrsxi}

Combines \textsf{izvrsxi} and \textsf{odbaci}.

Running state will be called and its result returned
as the result of \textsf{zavrsxi}, while the running
state is reset to null and void. This is a common
shorthand, like:

\begin{verbatim}
MAKRO Klasa(name)@regex./k/Klasa/@@zavrsxi.name@
@@
\end{verbatim}


\subsubsection{ako}

Enables two-way branching based on the parameter,
treated as Boolean. Always returns empty string.

Running state is set to an unnamed function which returns the
parameter as Boolean. With the help of functions \textsf{onda} and
\textsf{inacxe}, this enables something similar to usual
\textsf{if-then-else} from major programming languages.

\begin{verbatim}
MAKRO Animal(kind,bird)@ako.bird@@onda.Flies@ @@
\end{verbatim}

Formally, there is no end of the branch, but one can
dismiss the running state to prevent surprises.


\subsubsection{onda}

Calls/executes the running stae, interpreting the result
as Boolean. If true, returns its parameter, otherwise
returns an empty string.

Running state is not altered.

With the help of functions \textsf{ako} and
\textsf{inacxe}, this enables something similar to usual
\textsf{if-then-else} from major programming languages.

One can chain \textsf{onda}, or even have some other
calls between two \textsf{onda} in which case care should
be taken that the running state could be changed in between.

\begin{verbatim}
MAKRO Animal(kind,bird)@ako.bird@@onda.Flies@. @onda.Has Wings@ @@
\end{verbatim}

\subsubsection{inacxe}

Calls/executes the running stae, interpreting the result
as Boolean. If false, returns its parameter, otherwise
returns an empty string.

In all other aspects, it's just like \textsf{onda}.

\begin{verbatim}
MAKRO Animal(kind,bird)@ako.bird@@onda.Flies@@inacxe.Ground based@ @@
\end{verbatim}


\subsubsection{spram}

Writes its parameter into the current state, which further
enable complex processing, like multiway branches. To enable
multi-way branches, it also writes into the current state
the initial value of a ``has the value been found'', which is
false.

Always returns empty string.

To make a multi-way branch use it with \textsf{kad},
\textsf{onda} and \textsf{drukcxe}. Observe that \textsf{inacxe}
cannot be used for the \textsf{default/otherwise} branch.

\begin{verbatim}
MAKRO Animal(kind)@spram.kind@@kad.Eagle@@onda.Flies@@kad.Falcon@@onda.Flies@@drukcxe.Ground based@ @@
\end{verbatim}

\subsubsection{kad}

Conceptually, a variant of \textsf{ako} which compares its
parameter to the initial value (from  \textsf{spram}). It
returns the result of the comparison as Boolean. It preserves
the initial value and updates the ``value found'' indicator.

This enables chaining of branches with different values to compare
with.

Implementation of this is much more complex than \textsf{ako}.

First it calls/executes the running state, which returns the
initial value and sets the running state to current ``value
found'' indicator. Then a call to this updated running states
returns said indicator. Comparison of the initial value with
the parametar is performed and the result returned as Boolean,
while the running state is updated to hold the initial value
and the updated ``value found'' indicator.


\subsubsection{drukcxe}

Conceptually, a variant of \textsf{inacxe} which checks the
``value found'' indicator from the running state, rather than the
running state as a Boolean.

This is implemented by calling/executing the running state once,
ignoring the result (which should be the initial value), then
call to the updated running state will return the ``value found''
indicator. If value was not found, the parameter is returned,
otherwise an empty string is returned.

Since the running state not preserved, one cannot chain
 calls to \textsf{drukcxe}, unline \textsf{inacxe}.


\subsubsection{fako}

The parameter is a name of the function to call, then use
the result like a parametar for \textsf{ako}. It can be
thought of as ``functional if''.

Experience shows that a logical (Boolean) state is kept
in a user function and then branching on that state
cannot be done simply with \textsf{zovi} because it will
actually return the result.

\begin{verbatim}
MAKRO Frame(vrsta,ptica)@spram.yes@@uvedi._framed@@@
MAKRO .Framed@spram.no@@uvedi._framed@@@
MAKRO Roger(rabbit)@fako._framed@@onda.Framed@@inacxe.Free@@@
\end{verbatim}

Writing \verb+MAKRO Roger(rabbit)@_framed@+ would yield
\textsf{yes} or \textsf{no} first and then parameter for
\textsf{onda} or \textsf{inacxe}.


\subsubsection{fonda}

Similar to \textsf{onda} but returns the result of calling the function
given by the parameter rather than the parameter itself.

Running state is called and its result interpreted as Boolean. If true,
the function given by parameter will be called and its result returned,
updating the running state to true (because the called function might have
changed the running state). If false, just return an empty string.

Thus, we must be OK with dismissing any changes in the running state done
by the function in the parameter.


\subsubsection{fspram}

Similar to \textsf{spram} but uses the result of the funkction given with the
parameter rather than the parameter itself.

One could saz that  \textsf{fspram} is to \textsf{spram} what
\textsf{fako} is to \textsf{ako}.


\subsubsection{osiguraj}

Provides a waz to check for errors. Often used to check semantics of
script files that cannot be expressed in MAKRO language.

Running state is called and its result interpreted as Boolean. If false,
processing is aborted and error reported. If true, just return an empty string.

Here's how to make sure nobody framed Roger Rabbit.

\begin{verbatim}
MAKRO Frame(kind)@spram.yes@@uvedi._safe@@@
MAKRO .Frame@_safe@@osiguraj@@@
MAKRO Roger(rabbit)@spram.no@@uvedi._safe@@@
\end{verbatim}


\subsubsection{Comments}

A comment starts with the symbols \verb+//+ (as in C++) and ``lasts'' until the end
of that line.  Comments can appear in the macro file, but only outside
declaration and definition of macro and expansion. Comment within the macro declaration
or expansion declaration is not allowed, as well as among parameters in the definition
of a macro, and the symbol \verb+//+ , inside the macro definition, is
treated like any other symbol, i.e. is included in the replacement.


\subsubsection{Examples}

\begin{enumerate}

\item Here is the complete miniature macro file, with two macros and two
  expansion:
\begin{lstlisting}[language=macromac,basicstyle=\ttfamily\small,keywordstyle=\underline,showspaces=true]
DEKLARACIJE
    // Comment in the declaration
    macro1(param1,param2)
    Macro2
@@
// First expansion
RAZVOJ Dis1
MAKRO Macro1(param1,param2) The parameters of the macro are: @param1@ and @param2@.@@
MAKRO Macro2() This is macro 2@@

// Second expansion
RAZVOJ Raz2
MAKRO Macro1@
I still have the parameters: @param1@ and @param2@.@@
MAKRO Macro2
This is
Macro2
with new lines
@@
\end{lstlisting}

Macros are declared in the declarations section: \textsf{Macro1} with two
parameters and \textsf{Macro2} without parameters. For the expansion of \textsf{Raz1},
the first macro is defined as: \textsf{The parameters of the macro are: <first
  parameter> and <second parameter>.}, and others like \textsf{This is a macro
  2}. For Raz2 expansion, the first macro is defined as: \textsf{And further
  i have parameters: <first parameter> and <second parameter>.} and the second one as:
\textsf{<nr>This is<nr>macro2<nr>with newlines<nr>}, where with
\textsf{<nr>} marked newline symbol.

\item Notice that, in the previous example, the macro definitions are under expansion
  Raz1 in the first form, and in the expansion of Raz2 – in the second.

\item In the previous example, the second expansion could modify the first expansion,
  when not all macros have to be listed, but only those that are
  changed. For example, we could write:

\begin{lstlisting}[language=macromac,basicstyle=\ttfamily\small,keywordstyle=\underline]
// Second expansion
RAZVOJ Raz2 MENJA Raz1
// We only change Macro1
MAKRO Macro1@
Although I changed, I still have parameters: @param1@ and @param@.@@
\end{lstlisting}

In the expansion of Raz2, the first macro was defined as: \textsf{Although I changed, I still
have parameters: <first parameter> and <second parameter>.} and the second same as for
Raz1: \textsf{This is macro 2}.

\item Let's observe that in the definition of the macro Makro2 in the expansion of Raz1 it was
  necessary to write parentheses, in order to separate the macro from the substitution (otherwise it would
  read: \textsf{MAKRO Macro2This is macro 2@@} which would
  be reported as an error because no macro was declared as
  Macro2Ovo). Definition \textsf{MAKRO Macro2 This is macro 2@@} 
  can be used, but it defines the macro Macro2 as
  \textsf{<b>This<b>is<b>macro<b>2}, where \textsf{<b>} is 
  whitespace. In other words, the first white space after the name \textsf{Macro2} enters the
  replacement. Brackets served to avoid this phenomenon. In a similar way
  way, the symbol \textsf{@} was used in the expansion of \textsf{Raz2}, which
  is ignored (because it is at the end of the line) along with the newline character
  behind it.

\item Definition:

\begin{lstlisting}[language=macromac,basicstyle=\ttfamily\small,keywordstyle=\underline]
MAKRO Macro1(param1,param2)//This is macro 1
I have parameters: // Fixed text
@param1@ i // The first parameter
@param2@. // Second parameter
@@
\end{lstlisting}

defines a macro containing ``comments'' (in output file format)
included in the exchange. This is useful for later analysis of the generated
 code and is not executable in the C preprocessor.

\item Definition \textsf{MAKRO Empty@@} specifies an empty macro - macro
  which expands into an empty string of symbols.

\end{enumerate}



\subsection{Template-File Syntax}

The template must have the command \textsf{@KORISTI <filename>} in the first line, 
for example: \textsf{@KORISTI makroi/makro.mac}, which specifies
the macro-file. After this command, the template itself continues. Name of the
macro-file may also include the path to the file, relative to the
to the template file. In the first line after the file name the cannot be any
another text.


\subsubsection{Expansion calls in template}

Within the template, the command \textsf{@RAZVI <expansion name>} 
are replaced by a script expanded using macros from the given
macro-file, from the expansion specified in this command. In itself
macro files must have that expansion, otherwise an error is reported.
It is not an error if macro file contains an expansion not used in the template. 
The same expansion can appear more than once
in the template, although that almost never happens.

The command \verb+@RAZVI+ can be anywhere in the template and as its ending
the first symbol after the <expansion name> identifier is counted.


\subsubsection{Comments}

The symbol \verb+@/+ specifies the beginning of a comment in the template. Comment
``lasts'' until the end of that line of text. Comment must not be found inside
commands \verb+@RAZVI+ or \verb+@KORISTI+.

The entire comment in the output file is replaced with a single newline character.

\subsubsection{Including text files}

The syntax is the same as for including ``another script in a script'' -
\textsf{@"<filename>"}. Unlike scripts, in a template the inclusion
means including a text file verbatim, not including
another template. It is useful if there is some data that needs to be
repeated in multiple templates (say, version tags and the like).


\subsubsection{Other characters}

All other symbols from the template, which are not inside comments and are not some
from the commands \verb+@RAZVI+ or \verb+@KORISTI+ or \verb+@"..."+,
are written verbatim to the output file.

\subsubsection{Example}

The following template can be used with the macro file from the previous 
section:

\begin{lstlisting}[language=macrotem,basicstyle=\small\ttfamily,keywordstyle=\underline]
@KORISTI makro.mac
@/Suppose the macro file is called macro.mac
This is being copied verbatim, @/this is a comment
here -->>@RAZVIJ Raz1<<-- the first expansion is inserted,
and here -->>@RAZVIJ Raz2<<-- others!
\end{lstlisting}



\section{Example: enumerable types}

The problem we are solving is the following: we need to create a header (.h
file) that declared a certain number of enum-types in C programming language (with
corresponding values for symbols), as well as a .c file in which we will
define functions that for a parameter that is a given value
return a string with some ``name''. MAKRO expansions will ensure that
we keep the list of values in the script and do not need to update the 
independently the header file and source code (possibly introducing bugs).

Since we have two output files, each of them will have its own template,
the script will be unique, and one macro file is enough.

Here is an example script with two enumerable types:

\begin{lstlisting}[caption=enums.scr,language=macroscr,basicstyle=\ttfamily\small,keywordstyle=\underline]
@/ ******************************************
@/ Script-file with definitions of enums
@/ ******************************************

@@Enumeric(EDayInWeek,@[
    @@Value(dnMonday,0,"Monday")
    @@Value(dnTuesday,1,"Tuesday")
    @@Value(dnWednesday,2,"Wednesday")
    @@Value(dnThursday,3,"Thursday")
    @@Value(dnFriday,4,"Friday")
    @@Value(dnSaturday,5,"Saturday")
    @@Value(dnSunday,6,"Sunday")
@])
@@Enumeric(ERectangleColor,@[
    @@Value(dbRed,0,"Red")
    @@Value(dbOrange,1,"Orange")
    @@Value(dbYellow,2,"Yellow")
    @@Value(dbGreen,3,"Green")
    @@Value(dbBlue,4,"Blue")
    @@Value(dbIndigoBlue,5,"Indigo Blue")
    @@Value(dbPurple,6,"Purple")
@])
\end{lstlisting}

The header template would look like this:

\begin{lstlisting}[caption=enumh.tem,language=macrotem,basicstyle=\ttfamily\small,keywordstyle=\underline]
@KORISTI enum.mac
/****************************************
 * Header with defined enums
 **********************************************/

#if !defined INC_ENUMS
#define INC_ENUMS

/* Definitions of enums */
@RAZVI ENUMERICS

/* Function declarations for converting enums to strings */
@RAZVIJ DEKLFUN

#endif /* !defined INC_ENUMS */
\end{lstlisting}

The template for the source code would look like this:

\begin{lstlisting}[caption=enumc.tem,language=macrotem,basicstyle=\ttfamily\small,keywordstyle=\underline]
@KORISTI enum.mac
/****************************************
 * Module with conversion functions
 * enumerics to strings
 **********************************************/

#include <assert.h>
#include "enum.h"

@RAZVIJ FUNCONV
\end{lstlisting}

Macro definitions must be in a file declared within
template and it would look like this:

\begin{lstlisting}[caption=enum.mac,language=macromac,basicstyle=\ttfamily\small,keywordstyle=\underline]
DEKLARACIJE
    Enumeric(Name, ListValues)
    Value(Identifier, Value, Name)
@@

RAZVOJ ENUMERICS

MAKRO Enumeric(Name, ListValues)@
enum @Name@ {@
@ListaVrednosti@@
    @Name@_Max
};

@@

MAKRO Value(Identifier, Value, Name)@
@Identifier@ = @Value@,@@

RAZVOJ DECLFUN

MAKRO Enumeric(Name, ListValues)@
char *@Name@_String(enum @Name@ e);
@@

MAKRO Value@@

RAZVOJ FUNCONV

MAKRO Enumeric(Name, ListValues)@
char *@Name@_String(enum @Name@ e)
{
    switch (e) {@
@ListaValues@@
        default:
            assert(0);
    }
}

@@

MAKRO Value(Identifier, Value, Name)@
    case @Identifier@:
            return @Name@;@@
\end{lstlisting}

Upon execution of the MAKRO program for the header
(\verb+makro enum.scr enumh.tem enum.h+) gives:

\begin{lstlisting}[caption=enum.h,language=C,basicstyle=\small]
/****************************************
 * Header with defined enums
 **********************************************/

#if !defined INC_ENUMS
#define INC_ENUMS

/* Definitions of enums */
enum EDayInWeek {
    dnMonday = 0,
    dnTuesday = 1,
    dnWednesday = 2,
    dnThursday = 3,
    dnFriday = 4,
    dnSaturday = 5,
    dnSunday = 6,
    EDayInWeek_Max
};

enum ERectangleColor {
    dbRed = 0,
    dbOrange = 1,
    dbZuta = 2,
    dbGreen = 3,
    dbBlue = 4,
    dbIndigoBlue = 5,
    dbPurple = 6,
    ERectangleColor_Max
};


/* Function declarations for converting enums to strings */
char *EDayInWeek_String(enum DAYNWeek e);
char *ERectangleColor_String(enum ERectangleColor e);

#endif /* !defined INC_ENUMS */
\end{lstlisting}

By executing the MAKRO program for the source code (\verb+macro enum.scr enmumc.tem enum.c+)
we get:

\begin{lstlisting}[caption=enum.c,language=C,basicstyle=\small]
/****************************************
 * Module with conversion functions
 * enumerics to strings
 **********************************************/

#include <assert.h>
#include "enum.h"

char *EDayInWeek_String(enum DAYNWeek e)
{
    switch (e) {
        case dnMonday:
            return "Monday";
        case dnTuesday:
            return "Tuesday";
        case dnWednesday:
            return "Wednesday";
        case dnThursday:
            return "Thursday";
        case dnFriday:
            return "Friday";
        case dnSaturday:
            return "Saturday";
        case dnSunday:
            return "Sunday";
        default:
            assert(0);
    }
}

char *ERectangleColor_String(enum ERectangleColor e)
{
    switch (e) {
        case dbRed:
            return "Red";
        case dbOrange:
            return "Orange";
        case dbYellow:
            return "Yellow";
        case dbGreen:
            return "Green";
        case dbBlue:
            return "Blue";
        case dbIndigoBlue:
            return "Indigo Blue";
        case dbPurple:
            return "Purple";
        default:
            assert(0);
    }
}
\end{lstlisting}



\section{Example Explanation}

Let's now show how the output files are created based on the
script. First of all, the macros \verb+Enumeric+ and  \verb+Value+ are used in the script. 
The script is expanded twice in the header and once in the
source code files. The reader will easily see that the header has been created with
substitutions \textsf{@RAZVI ENUMERICS} and \textsf{@RAZVI DECLFUN}, and
source code by replacing \textsf{@RAZVI FUNCONV}. By the way, in the template
the macro-file is given with command \textsf{@KORISTI enum.mac} in the first line.

The parameters of the macro \verb+Enumeric+ are: the name of the enum and ``everything else'' -
macro calls \verb+Value+. The macro \verb+Value+ is
nested. The parameters of the macro \verb+Value+ are: enum identifier, 
its value and ``name''. When a macro is expanded, first
its parameters expand, and then it itself expands.

In the macro file there is a declaration section, where the
macros used are declared. In our case, it is \verb+Enumeric+ and
\verb+Value+, where the number of formal parameters in parentheses after
names determines the number of parameters of the macros themselves in any expansion
(\verb+Enumeric+: 2 parameters, \verb+Value+: 3 parameters).

This header is followed by macro expansions: \verb+ENUMERICS+,
\verb+DEKLFUN+ and \verb+FUNKONV+. For each of the three expansions 
separate definitions are given with directives \verb+MAKRO+. In this example, 
parameter names are listed only in those definitions where it is parameters
are actually used, while they are dropped where the corresponding macro is
defined as empty (eg macro \verb+Value+ in expansion
\verb+DECLFUN+).

Let's look at the macros for developing \verb+ENUMERICS+:

\begin{lstlisting}[showspaces=true,language=macromac,keywordstyle=\underline,basicstyle=\ttfamily]
RAZVOJ ENUMERICS
MAKRO Enumeric(Name, ListValues)@
enum @Name@ {@
@ListaVrednosti@@
    @Name@_Max
};

@@
MAKRO Value(Identifier, Value, Name)@
@Identifier@ = @Value@,@@
\end{lstlisting}

The definition of each macro begins with the command MAKRO and ends with a symbol
@@.  Macro parameters are delimited by @ symbols.
(eg \textsf{@Name@}). The symbol @ at the end of the line indicates that that
the end of the line is not taken into account when expansion. With that exception, in
all white spaces, tabs and newline characters from the definition of the macro
appear in the macro definition. This means that the 
macro \verb+Enumeric+ is defined like this:

\begin{lstlisting}[showspaces=true,basicstyle=\ttfamily,keywordstyle=\underline]
enum @Name@ {@ListValues@ @Name@_Max
};

\end{lstlisting}

The macro \verb+Value+ is only defined as:

\begin{lstlisting}[showspaces=true,basicstyle=\ttfamily]
@Identifier@ = @Value@,
\end{lstlisting}

without newline characters.

Now let's see what the script expands into using these macros. Inside of
script, the macros are specified with the command @@<macro name>(<parameters>). U
in the above script we have at the basic level the call of only macro Enumeric two
times, but using macro calls as parameters. 
Between macro calls, whitespace, tabs, and newline characters
are ignored, but within parameters they are significant. This means that 
when calling the first macro \verb+Enumerik+ within the script, its parameters are as follows:

\begin{verbatim}
EDayInWeek
\end{verbatim}

and:

\begin{lstlisting}[showspaces=true,basicstyle=\ttfamily]

    @@Value(dnMonday,0,"Monday")
    @@Value(dnTuesday,1,"Tuesday")
    @@Value(dnWednesday,2,"Wednesday")
    @@Value(dnThursday,3,"Thursday")
    @@Value(dnFriday,4,"Friday")
    @@Value(dnSaturday,5,"Saturday")
    @@Value(dnSunday,6,"Sunday")
\end{lstlisting}

The @[ and @] symbols, which limit the second parameter of the \verb+Enumerical+ macro 
are, in fact,  not necessary, but not harmful either. Namely, brackets and
commas that appear within the second parameter are nested
calls and there are no problems with their position, regardless of whether 
symbols @[ and @] are used or not.  However, it is a good practice to
always enclose complex parameters with @[ and @] symbols 
(spans multiple lines, contains special symbols, etc.). Namely,
in this way, the macro call is more transparent, some editors are able to
to match (as brackets) the symbols @[ and @], and protects from
occurrences of the symbols ',' and ')' in the parameter (the programmer does not even have to think
do they appear in this version, and will they appear in any of the
future script revisions).

Now it is clear how the macro \verb+Enumeric+ is expanded. In the first pass
the above two parameters of the macro are expanded, with the first one not being expanded
further (because it does not contain new macros), and the second evolves into:

\begin{lstlisting}[showspaces=true,basicstyle=\ttfamily]

    dnMonday = 0,
    dnTuesday = 1,
    dnWednesday = 2,
    dnThursday = 3,
    dnFriday = 4,
    dnSaturday = 5,
    dnSunday = 6,
\end{lstlisting}

Then the \verb+Enumeric+ macro itself is expanded and we get:

\begin{lstlisting}[showspaces=true,basicstyle=\ttfamily]
enum EDayInWeek {
    dnMonday = 0,
    dnTuesday = 1,
    dnWednesday = 2,
    dnThursday = 3,
    dnFriday = 4,
    dnSaturday = 5,
    dnSunday = 6,
    EDayInWeek_Max
};

\end{lstlisting}

which is the desired result. Others are expanded in a similar way.


\section{Example enhancements with block macros}

By using block macros it is possible to perform the same as in the example with
``nested'' macros, but that's not very interesting.  It is interesting that
we can use macro opening arguments in macro expansion inside the
block.

We are just sketching the differences compared to the given example, but the bottom line is that with
with the help of block-macro we can avoid the need for ``inventing''
symbol prefixes:

\begin{lstlisting}[caption=enums.scr,language=macroscr,basicstyle=\ttfamily\small,keywordstyle=\underline]
@@Enumeric(EDayInWeek)
    @@Value(Monday,0,"Monday")
    @@Value(Tuesday,1,"Tuesday")
@.Enumeric
\end{lstlisting}

The \texttt{Enumeric} macro becomes a block-macro, so it needs to throw out the parameter that was used to ``collect''
values, and divide the definition into two parts.

The \texttt{Value} argument should be used in macro definitions
\texttt{Name} of the \texttt{Enumeric} macro.

\begin{lstlisting}[caption=enum.mac,language=macromac,basicstyle=\ttfamily\small,keywordstyle=\underline]
DEKLARACIJE
    Enumeric(name)
    Value(Ident, Value, Description)
@@

RAZVOJ ENUMERICS

MAKRO Enumeric(Name)enum @Name@ {@@
MAKRO .Enumeric @Name@_Max
};

@@
MAKRO Value(Ident,Value,Description)@Enumeric.Name@_@Ident@ = @Value@,@@
\end{lstlisting}

Of course, it is necessary to make a suitable change for other expansions.

By expanding after these changes, we get (we give only the ``interesting'' part, for the sake of illustration):

\begin{lstlisting}[caption=enum.h,language=C,basicstyle=\small]
/* Definitions of enums */
enum EDayInWeek {
    EDayInWeek_Monday = 0,
    EDayInWeek_Tuesday = 1,
    EDayInWeek_Max
};
\end{lstlisting}

Maybe someone doesn't like to get such ``long'' names for certain 
symbolic constants, and still wants to ``invent'' a prefix.  By use of
block macro we can avoid repeating the prefix for each symbol:

\begin{lstlisting}[caption=enums.scr,language=macroscr,basicstyle=\ttfamily\small,keywordstyle=\underline]
@@Enumeric(EDayInWeek, dn)
    @@Value(Monday,0,"Monday")
    @@Value(Tuesday,1,"Tuesday")
@.Enumeric
\end{lstlisting}

The macro \texttt{Enumerik} gets a new parameter, the prefix \texttt{Pref},
and in macro definitions \texttt{Value} instead of argument
\texttt{Name} macro \texttt{Enumeric} should use that new 
  argument \texttt{Pref}:

\begin{lstlisting}[caption=enum.mac,language=macromac,basicstyle=\ttfamily\small,keywordstyle=\underline]
DEKLARACIJE
    Enumeric(Name, Pref)
    Value(Ident, Value, Description)
@@

RAZVOJ ENUMERICS

MAKRO Enumeric(Name,Pref)enum @Name@ {@@
MAKRO .Enumeric @Name@_Max
};

@@
MAKRO Value(Ident,Value,Name)@Enumeric.Pref@@Ident@ = @Value@,@@
\end{lstlisting}

This produces the same output as in the example without using block macros.
The advantage is that we have ensured that the prefix for each symbol is the same and 
we don't need to repeat it in every definition.

\end{document}
